function [PP]=PLOTPARAMS(varargin) % function [IP]=INIT(varargin) % INIT = init parameters


m=255;
PP.x_label_param_lines_ur = 'Learning Rate';
PP.x_label_param_lines_el = 'Exploration Level';
PP.x_label_param_lines_df = 'Discount Factor';
PP.x_label_param_lines_spr = 'Spread';
PP.x_label_param_lines_hs = 'Hindsight';
PP.label_font_size = 16;
PP.pi_label_font_size = 14;
PP.pi_legend_font_size = 14;
PP.title_font_size = 18;
PP.y_label_param_lines = 'Performance';

PP.colOrange = [255/m 112/m 1/m]; % orange
PP.colBlue = [1/m 112/m 255/m]; % blue

PP.colLOrange = [200/m 92/m 1/m]; % orange
PP.colLBlue = [1/m 92/m 200/m]; % blue

PP.colRed=[255/m 30/m 10/m]; % red

PP.colGreen=[153/m 204/m 101/m];%[] %[61/m 165/m 1/m]; % green 153,204,101
PP.colDarkRed=[143/m 1/m 1/m]; % dark red
PP.colBlackishGreen=[23/m 71/m 65/m]; % blackish
PP.colBlackish=[23/m 11/m 15/m]; % blackish
PP.colLightGrey=[190/m 190/m 190/m]; % blackish
PP.colGrey=[160/m 160/m 160/m]; % blackish
PP.colYellow=[204/m 204/m 101/m]; % yellow green
PP.colBrown=[204/m 153/m 101/m];%204,153,101
PP.colTomato =[255/m 99/m 71/m]; %255,99,71
PP.colLionYellow = [255/m 191/m 71/m];%(255,191,71)
PP.colYellowGreen = [117/m 208/m 10/m];%117,208,10
PP.colSkyblue = [12/m 175/m 238/m] ;%12,175,238
PP.colGreen=[85/m 154/m 5/m]; % green


PP.col_(1,:)=PP.colOrange;
PP.col_(2,:)=PP.colBlue; 
PP.col_(4,:)=PP.colDarkRed; 
PP.col_(3,:)=PP.colGreen;



% for 7 scenarios of change
PP.col2_(1,:)=PP.colTomato; 
PP.col2_(2,:)=PP.colSkyblue;
PP.col2_(3,:)=PP.colYellowGreen;
PP.col2_(4,:)=PP.colGrey;
PP.col2_(5,:)=PP.colLionYellow;
PP.linew = 1;
PP.logName = 'Logistic';
PP.hystName = 'Threshold';
PP.fontSizeNormal = 18;
PP.fontSizeSmall = 14; 
PP.fontSizeXL3 = 12;
PP.fontSizeXL4 = 26;

PP.fontSizeXL4b = 20;

PP.fontSizeLarge3 = 10;

PP.fontSizeNormal3 = 8;
PP.fontSizeSmall3 = 6; 



PP.PIR = 'Performance Index';
PP.OCagent = 'OC Agent';
PP.OC = 'OC';

PP.OClog = 'Logistic';
PP.OClogAgent = 'Logistic Agent';
PP.OChyst = 'Threshold';
PP.OChystAgent = 'Threshold Agent';


PP.bgcolor1 = 'b';
