
% calculates performance index and takes the analythical solution and agent solution
function [PImean PIstd PImedian ] = calculatePerformanceIndex2(anAction, ...
    action,anState, state, anReward, reward,method, ...
     the_start_index, grc)
 %errbar = 1 gives the 50 initvidual simulation runs result
PImean=-Inf;
if PImean == 1
    PImean = zeros (50,1);
end
startCnt = the_start_index;
insize = size (action);
nCols = insize (1,2);
nRows = insize (1,1);

if strcmp(method, 'r_mae')
    if sum(reward) == 0
        PImean = 0;
    else
        
        
        %dmin=-1;%min(min(reward), min(anReward));
        %dmax=9.1;%max(max(reward), max(anReward));
        %rewardNo = (reward - dmin) ./ (dmax - dmin);
        %anRewardNo = (anReward - dmin) ./ (dmax - dmin);
        
        % skip normalising
        for i_row = 1:nRows
           % rew = reward(i_row,startCnt:nCols)
            
           % an_rew = (anReward(i_row,startCnt:nCols))
           %if strcmp(grc, 'abDecR')
           % sum_rew = sum(reward(i_row,startCnt:nCols))
           % sum_an_rew = sum(anReward(i_row,startCnt:nCols))
           % piii = sum_rew / sum_an_rew
            
           %end
            diffr1 (i_row, 1)= sum(reward(i_row,startCnt:nCols)) / sum(anReward(i_row,startCnt:nCols));
            %clear ocAction  ocReward
        end
        %        diffr= 1 - sum(( anReward(startCnt:rCols) - reward(startCnt:rCols)).^2)/(rCols-startCnt);
        diffr = sum(diffr1) / max(size(diffr1));
        if isnan([diffr])
            %r1=rewardNo
            %r2=anRewardNo
            %r3=(anRewardNo-rewardNo).^2
            %r4=(rewardNo + anRewardNo).^2
            %r5=sum( (anRewardNo-rewardNo).^2 ./ (rewardNo + anRewardNo).^2)
        end
        %    PImean=1-diffr/rCols;
        PImean=diffr;
    end
    
elseif strcmp(method, 'a_rel')
    if sum(reward) == 0
        PImean = 0;
    else
        
        loss=zeros(nRows, 1);
        for i_row = 1:nRows
           ag_a_seed_i = action(i_row,startCnt:nCols);
           oc_a_seed_i = anAction(i_row,startCnt:nCols);
            
           ag_s_seed_i = state(i_row,startCnt:nCols);
           oc_s_seed_i = anState(i_row,startCnt:nCols);
           
           ag_r_seed_i = reward(i_row,startCnt:nCols);
           oc_r_seed_i = anReward(i_row,startCnt:nCols);
           %absolute in each time step
          % loss (i_row, 1) = sum(ag_r_seed_i - oc_r_seed_i) / max(size(reward));
           %relative in each time step
           if ag_a_seed_i < 0
               min_value = abs (min(ag_a_seed_i));
           else
               min_value = 0;
           end
           ag_a_seed_i = ag_a_seed_i + min_value;
          
           oc_a_seed_i = oc_a_seed_i + min_value;
           
           the_diff (i_row, 1) = sum(abs(oc_a_seed_i - ag_a_seed_i) ) / max(size(ag_a_seed_i));%/ sum(oc_a_seed_i);% max(size(reward)); % per timesteps
           diffr1 (i_row, 1)= sum(action(i_row,startCnt:nCols)) / sum(anAction(i_row,startCnt:nCols));
    
        end
    
        diffr = sum(the_diff) / max(size(the_diff));
       % loss_average = sum(loss) / max(size(loss)); % average over all seeds
%         if loss_average < 0 
%             loss_average
%             disp ('loss_average < 0 in calculate performance index')
%             
%         end
        if isnan([diffr])
            disp('isnan([diffr])')
            pause
        end
    
        PImean=(1-diffr);
    end

    

elseif strcmp(method, 'r_rel')
    if sum(reward) == 0
        PImean = 0;
        PIstd = 0;
        PImedian = 0;
    else
        
        loss=zeros(nRows, 1);
        for i_row = 1:nRows % number of seeds
           ag_r_seed_i = reward(i_row,startCnt:nCols);
           oc_r_seed_i = anReward(i_row,startCnt:nCols);
            
           ag_s_seed_i = state(i_row,startCnt:nCols);
           oc_s_seed_i = anState(i_row,startCnt:nCols);
           
           ag_a_row_i = action(i_row,startCnt:nCols);
           oc_a_row_i = anAction(i_row,startCnt:nCols);
           
%            if ~isempty (find (state(i_row,1:3) ~= 0.55)) ...
%                    &&  isempty(find (round(state(i_row,1:3) .* 100) ./ 100 == 0))
%                plotme = state(i_row,1:3)
%            end
%            if ~isempty (find (anState(i_row,1:3) ~= 0.55))  ...
%                    &&  isempty (find (anState(i_row,1:3) == 0))
%                 plotme = anState(i_row,1:3)
%            end
%            if ~isempty(find (action(i_row,1:3) ~= 0.4500))  ...
%                     && isempty(find (round(action(i_row,1:3) .* 100) ./ 100 == 0))
%                 plotme = action(i_row,1:3)
%            end
%            
%            if ~isempty(find (round(anAction(i_row,1:3) .* 100) ./ 100 ~= 0.4500)) ...
%                    && isempty(find (round(anAction(i_row,1:3) .* 100) ./ 100 == 0))
%                 plotme = anAction(i_row,1:3)
%            end
           
     
           % absolute in each time step
           % loss (i_row, 1) = sum(ag_r_seed_i - oc_r_seed_i) / max(size(reward));
           % relative in each time step
          
           % fix that all values are positive
           min_value1 = min(ag_r_seed_i);
           if min_value1 < 0
               min_value = abs (min_value1);
           else
               min_value = 0;
           end
           
           ag_r_seed_i = ag_r_seed_i + min_value;
          
           oc_r_seed_i = oc_r_seed_i + min_value;
           
           loss (i_row, 1) = sum(oc_r_seed_i - ag_r_seed_i)  / sum(oc_r_seed_i);% max(size(reward)); % per timesteps
           loss2 (i_row, 1) = sum( ag_r_seed_i)  / sum(oc_r_seed_i);% max(size(reward)); % per timesteps
           loss3 (i_row, 1) = sum( ag_r_seed_i  ./ oc_r_seed_i) / max(size(oc_r_seed_i));% max(size(reward)); % per timesteps
           test = 1 - loss2; %xxx
           diffr1 (i_row, 1)= sum(reward(i_row,startCnt:nCols)) / sum(anReward(i_row,startCnt:nCols));
    
        end
    
        diffr = mean(diffr1);
        loss_average = mean(loss); % average over all seeds
        
        loss2_average = mean(loss2);
        if loss_average < 0 
            loss_average
            disp ('loss_average < 0 in calculate performance index')
            
        end
        if isnan([diffr])
            disp('isnan([diffr])')
            pause
        end
    
        PImean     = (1 - loss_average); %xxx
        PIstd      = std (ones ( size (loss)) - loss);
        PImedian   = median (ones ( size (loss)) - loss);
        
    end
    
elseif strcmp(method, 'b_mae') % as a_mae but best action in relation to current state
    
    
    %         for i = startCnt:200
    K=1.0;
    %             g=grcChange(i);
    %             OCaction(i-startCnt+1) = max(0, 1 + g*(1-states(i)/K) ...
    %                 - (K+0.1)/(2*states(i)));
    %         end
    
    for i_row=1:nRows
        
        % for i=1:200
        %    g=grcChange(i);
        %    ocAction(i) = max(0, 1 + g * (1 - state(i_row, i) / K) ...
        %        - (K + 0.1) / (2 * state(i_row, i)));
        %end
        %diffr(i_row, :)=sum(abs (action(i_row, startCnt:200) - ocAction(1, startCnt:200)));
        len = length(anAction(i_row,startCnt:nCols));
        sum_abs_diff = sum( abs (action(i_row,startCnt:nCols) -  anAction(i_row,startCnt:nCols) ));
        %sum_an_a = sum (anAction(i_row,startCnt:nCols));
        wrong_percentage = sum_abs_diff; %/ sum_an_a;
        %wrong_percentage (isnan(wrong_percentage)) = 0;
        
       diffr2 (i_row, 1) =  wrong_percentage / len;%sum (wrong_percentage) / length(abs_diff);  
       
        %diffr2 (i_row, 1) = sum(abs(action(i_row,startCnt:nCols) - ...
         %   anAction(i_row,startCnt:nCols)))
        
        %clear ocAction  ocReward
       
    end
   
    %        diffr= 1 - sum(( anReward(startCnt:rCols) - reward(startCnt:rCols)).^2)/(rCols-startCnt);
    if sum(diffr2) ~= 0
       len_diffr2 = length(diffr2); 
        diffr = sum(diffr2) / len_diffr2; % average over seeds
        PImean= diffr;

    else
        PImean = 0;
    end
    
    
    
    % action performance with over under exploitation
elseif strcmp(method, 'a_mae_ou') % as a_mae but best action in relation to current state
    
    for i_row=1:nRows
        % agent 0.5 real action 0.3 the over expl 0.2
        % agent 0.5 real 0.6 then under expl -0.1 agent - analytical
        %diffr2 (i_row, 1)= sum ( action (i_row, startCnt:nCols) ...
         %   - anAction (i_row, startCnt:nCols));
     
     
        diffr2 (i_row, 1) = sum ( action (i_row, startCnt:nCols) ...
            - anAction (i_row, startCnt:nCols));
        
    end
    
    if sum(diffr2) ~= 0
        diffr1 = diffr2 ./ (nCols - startCnt + 1);   % average per step
        diffr = sum(diffr1) / nRows; % average over seeds
        PImean= diffr;
    else
        PImean = 0;
    end
end


end