% find best agents for different types of change
function outSS=startSimulation(spanPerParam, steps, seeds, learningType, ecoFcns, useRL, plotMMForPaper, learningRate, ...
    testParams, findOptimalParams, runSim, trainingType, accountForCutTrace, doCutTrace, useSprimByAgent, ...
    runsPerDropSeries, startStates, startActions, useET, bestParamValuesForLinspace, grcIn, numClusters, ...
    bpconsta,   bplininc, bplindec, bpslowco,bpfastco, bpabdecr,bpabincr, bpabrand, grc_opt)

close all
tic
Strategies  = [2]; % neural network agent with 2 inputs (action and state)
grc = grcIn; %{'slowcos' 'abIncR' 'linearInc' 'abDecR' 'linearDec' 'abRand' 'cos'  'constant'};
%grc         = {'cos'  'constant'};
nrbfs = bpconsta(1,4);
%spanPerParam  = 120; % Hur m?nga tester ex 10000 som vi har i stora testet
%steps       = 100; % how many fishing rounds
%seeds       = 30;

runsPerSA   = 5; % how manyrounds to train the steps but with different start state and start actions
%ecoFcn = 'logistic' % the eco function static, logistic or hysteresis
%ecoFcns     = {'logistic', 'hysteresis'};
%learningType= 'unsupervised' % supervised vs unsupervised

%[stat, mess] = fileattrib;

% data is saved in this folder
fcn = 'runAgentsGrc';
dataFolder = 'Data';
name = strcat('../', dataFolder);%strcat(fullfile(mess.Name, dataFolder));
%pathAgentX = strcat(fullfile(mess.Name), filesep, 'MatlabAgent');
%path(path, name)
%path(path, pathAgentX)
perforIndex = createRepMat(-1);
perforAIndex = createRepMat(-1);
%accountForCutTrace = true; % cut trace when a drop has occured
%param headers
headers = {'dr ' 'ss ' 'lr ' 'rbfs ' 'rbf_spread_div '  'smtemp ' 'lambda ' 'gaer' 'perforAIndex' 'perforIndex' 'RL' 'ET' 'spread'};
%        out = [dr ss lr rbfs rbf_spread_div smtemp lambda gaer perforAIndex perforIndex useRLmat useETmat spread];

seed=678;%6789 % round(rand*1000);%+%83649447; %836494478

result={};
eLevels = [1];

if strcmp(runSim, 'randoms')
    parNos = 99;
    createRandoms = true;
elseif plotMMForPaper == 1
    parNos = 1;
    createRandoms = false; % create linear
elseif strcmp(runSim, 'linspace') || strcmp(runSim, 'gaLinspace') ...
        || strcmp(runSim, 'robust')
    parNos = testParams;
    createRandoms = false; % create linear
    
else
    disp('error in start sim')
end
% ---- SIMULATE AND SAVE --- %


for npt=1:length(parNos)
    parNo = parNos(npt)
    for nEF=1:length(ecoFcns)
        
        
        ecoFcn = ecoFcns{nEF}
        catalogueName = strcat(learningType, ecoFcn);
        
        for n=1:length(Strategies)
            %try
            if Strategies(n) == 2
                policy = 'softmax';
                numInputs = 2;
                tmpseeds = seeds;
            end
            clear  paramValues
            
            
            for i=1:max(size(grc))
                grc(i)
                
                % create matrix for simulation
                paramValues=loadParams(n,parNo, testParams, useRL, learningRate, trainingType, ecoFcn, useET, grc(i));
                fixedParamValues = loadFixedParamValues(learningRate, trainingType, ecoFcn, useET, grc(i));
                %s=size(paramValues);
                %numCols=s(1,2);
                
                pIndex=ones(spanPerParam,1);
                calcAnSolution = true;
                if doCutTrace == true
                    anseeds = seeds;
                else
                    anseeds=1; % analythical is always the same duh
                end
                seedRNG = rng(seed);
                anResult = feval(fcn, {dataFolder, '',{paramValues(1,:)}, grc(i), calcAnSolution, steps, policy, seed, numInputs, anseeds, runsPerSA, ecoFcn, learningType, plotMMForPaper, [], findOptimalParams, accountForCutTrace, doCutTrace, useSprimByAgent, runsPerDropSeries, startStates, startActions});
                
               
                % if useClusters == true
                %parfor j=1:spanPerParam
                for j=1:spanPerParam
                     seedRNG = rng(seed);
                    calcAnSolution  = false;
                    
                    result1          = feval(fcn, {dataFolder, '', {paramValues(j,:)}, grc(i), calcAnSolution, steps, policy, seed, numInputs, tmpseeds,runsPerSA, ecoFcn, learningType, plotMMForPaper, anResult, findOptimalParams, accountForCutTrace, doCutTrace, useSprimByAgent,  runsPerDropSeries, startStates, startActions});
                    result(j,:) = result1(1,1:11);
                    resultX(j,:) = result1(1,1:10);
                    tmpResult(j,:)  = result1(1,1:3);
                    optPath(j,:)    = result1{1,4};
                    eLevel(j,:)     = result1(1,6);
                    optPaths(j,:)   = result1(1,10);
                    agents(j,:)     = result1(1,11);
                    %        out={averageAMatrix averageSMatrix averageRMatrix averageOptPath averageEMatrix eM aM sM rM oM};
                    actions(j,:)   = result1(1,7);
                    states(j,:)    = result1(1,8);
                    rewards(j,:)   = result1(1,9);
                    pIndex(j,1)     = 0;%xxx calculatePerformanceIndexOrig(anResult, result1, 'r_mae');
                    pAIndex(j,1)    = 0;%xxx calculatePerformanceIndexOrig(anResult, result1, 'exploration_mae');
                end
       
                paramValues(:,9)  = pIndex(:,1);
                paramValues(:,10) = pAIndex(:,1);
                outSS=char(strcat(dataFolder,'_NR_', num2str(spanPerParam),'_NS_', ...
                    num2str(steps), '_Seeds_', num2str(seeds), '_p_'));
                
                pathandname=char(strcat( name ,filesep, catalogueName, filesep, grc{i}, filesep,num2str(nrbfs), dataFolder,'_NR_', num2str(spanPerParam),'_NS_', ...
                    num2str(steps), '_Seeds_', num2str(seeds) ,'_p_',num2str(parNo),'.mat'));
                
                growthrc=grc(i);
                % save(pathandname, 'paramValues', 'headers', 'name', 'dataFolder', 'growthrc', 'seed', 'steps', 'spanPerParam', 'policy', 'numInputs', 'seeds','anResult', 'result', 'tmpResult', 'optPath', 'fixedParamValues');
                %clear pIndex tmpResult pAIndex;
                
                
                %%%%%%%%%%%%%
                
                % save(pathandname, 'paramValues', 'headers', 'name', 'dataFolder', 'growthrc', 'seed', 'steps',...
                %    'spanPerParam', 'policy', 'numInputs', 'seeds','anResult', 'result', 'tmpResult',...
                %   'optPath', 'fixedParamValues');
                result(:, 11) = []; % remove agents to have easier files to work with
                if strcmp(runSim, 'robust')
                    par = grc_opt;
                else
                    par = num2str(parNo);
                end
                pathandname=char(strcat( name ,filesep, catalogueName, filesep, grc{i}, filesep, num2str(nrbfs),'L',dataFolder,'_NR_', num2str(spanPerParam),'_NS_', ...
                    num2str(steps), '_Seeds_', num2str(seeds) ,'_p_',par,'.mat'));
                
                save(pathandname, 'paramValues', 'headers', 'name', 'dataFolder', 'growthrc', 'seed', 'steps',...
                    'spanPerParam', 'policy', 'numInputs', 'seeds','anResult', 'result', 'tmpResult',...
                    'optPath', 'fixedParamValues');
                clear pIndex tmpResult pAIndex  eLevel optPath optPaths actions states rewards resultX paramValues;
                result =   {};
                eLevels = [1];
            end
            %     catch ME1
            %         disp('error in save, simulateRemoteParallel.m')
            %         idSegLast = regexp(ME1.identifier, '(?<=:)\w+$', 'match')
            %         disp([ME1.stack])
            %     end
            
        end
    end
end


% -----   FUNCTIONS ---- %
    function out = loadFixedParamValues(learningRate, trainingType, ecoFcn, useET, grcFcn)
    
        if strcmp(runSim, 'robust')|| strcmp(runSim, 'gaLinspace')
            
            
            %  OC     0.3342    0.5303    1.0000   81.0000    0.5700    0.0006    0.2540    1.0000    0.9873    0.0237    1.0000    1.0000    4.9423
            if strcmp(ecoFcn, 'logistic')
                
                if strcmp(grcFcn, 'constant') %'constant' 'linearInc' 'slowcos' 'cos' 'abRand' 'abDecR' 'linearDec'  'abIncR' };
                    bestParamValuesForLinspace = bpconsta;
                elseif strcmp(grcFcn, 'linearInc')
                    bestParamValuesForLinspace = bplininc;
                elseif strcmp(grcFcn, 'slowcos')
                    bestParamValuesForLinspace = bpslowco;
                elseif strcmp(grcFcn, 'cos')
                    bestParamValuesForLinspace = bpfastco;
                elseif strcmp(grcFcn, 'abRand')
                    bestParamValuesForLinspace = bpabrand;
                elseif strcmp(grcFcn, 'abDecR')
                    bestParamValuesForLinspace = bpabdecr;
                elseif strcmp(grcFcn, 'linearDec')
                    bestParamValuesForLinspace = bplindec;
                elseif strcmp(grcFcn, 'abIncR')
                    bestParamValuesForLinspace = bpabincr;
                end
                
                dr_             = bestParamValuesForLinspace(1,1);
                ss_             = bestParamValuesForLinspace(1,2);
                rbfs            = bestParamValuesForLinspace(1,4);
                smtemp_         = bestParamValuesForLinspace(1,6);
                lambda_         = bestParamValuesForLinspace(1,7);
                spread_         = bestParamValuesForLinspace(1,13);
                
            elseif strcmp(ecoFcn, 'hysteresis')
                dr_             = bestParamValuesForLinspace(2,1);
                ss_             = bestParamValuesForLinspace(2,2);
                rbfs            = bestParamValuesForLinspace(2,4);
                smtemp_         = bestParamValuesForLinspace(2,6);
                lambda_         = bestParamValuesForLinspace(2,7);
                spread_         = bestParamValuesForLinspace(2,13);
            end
            
        end
        % COMMON -----------------------------
        useET_          = useET;
        
        lr_             = learningRate;
        rbf_spread_div_ = 0.57;%0.57;
        out = [dr_, ss_, lr_, rbfs, rbf_spread_div_, smtemp_, lambda_, useET_, spread_ ];
    end

    function out = loadParams(i, parNo, testParams, useRL, learningRate, trainingType, ecoFcn, useET, grcFcn)
        gaer = createRepMat(1);
        
        fixedVals(:,:)      = loadFixedParamValues(learningRate, trainingType, ecoFcn, useET, grcFcn);
        dr                  = createRepMat(fixedVals(1,1));
        ss                  = createRepMat(fixedVals(1,2));
        lr                  = createRepMat(fixedVals(1,3));
        rbfs                = createRepMat(fixedVals(1,4));
        rbf_spread_div      = createRepMat(fixedVals(1,5));
        smtemp              = createRepMat(fixedVals(1,6));
        lambda              = createRepMat(fixedVals(1,7));
        useRLmat            = createRepMat(useRL);
        useETmat            = createRepMat(fixedVals(1,8));
        spread              = createRepMat(fixedVals(1,9));
        
        
        % Methods paper: FIXATING the parameter values
        if strcmp(runSim, 'robust')
            % already correct value do nothing
        else
            if parNo == 1
                dr = linspace(0,1, spanPerParam)';
            elseif parNo == 2
                ss = linspace(0,1, spanPerParam)';
            elseif parNo == 4
                if spanPerParam > 2
                    rbfs = repmat([nrbfs]',spanPerParam, 1 );
                end
            elseif parNo == 5
                rbf_spread_div = linspace(0.4,1.0, spanPerParam)';
            elseif parNo == 6
                smtemp = logspace(-2.7,0,spanPerParam)';
                
                %smtemp = createExpRandoms(0.02, spanPerParam).*0.01;%linspace(0.000001, 0.0001, spanPerParam)';
            elseif parNo == 7
                lambda = linspace(0,1, spanPerParam)';
                
            elseif parNo == 13
                spread = linspace(0.5,6.5, spanPerParam)';
            end
            
       end
            out = [dr ss lr rbfs rbf_spread_div smtemp lambda gaer perforAIndex perforIndex useRLmat useETmat spread];
        
    end

    function out = createExpRandoms(lowerLimit, spanPerParam)
        out=(exp(rand(spanPerParam,1).*log(lowerLimit)));
    end

    function out = createLinearRandoms(lowerBound, topBound, spanPerParam)
        out=lowerBound+(((rand(spanPerParam,1)).*(topBound-lowerBound)));
    end

    function out = createRepMat(input)
        %mat = repmat(input, 1, ceil(spanPerParam/length(input)))';
        %out=mat([1: spanPerParam]);
        out=repmat(input, 1,spanPerParam)';
    end


elapsedTimeInMinutes = toc/60
elapsedTimeInHrs=elapsedTimeInMinutes/60
pathandname
disp('I am done startSimulation!')

end % end function